var shortcodeDefaults = {
    buttons     : 'facebook,twitter,googleplus,pinterest,linkedin,whatsapp',
    size        : 'medium',
    color       : '#',
    hoverColor  : '#',
};
var shortcode = shortcodeDefaults,
    blink,
    $shortcodeHolder,
    $orderElem,
    $shortcodeUpdateElem;

jQuery(document).ready(function($) {

    $shortcodeHolder = jQuery('#shortcode-holder');
    // $shortcodeUpdateElem = jQuery('#ess-shortcode-update-notice');
    $shortcodeUpdateElem = document.getElementById('ess-shortcode-update-notice');

    // Farbtastic Color Picker
    $('.color-picker-input').hide();
    $('.color-picker-input').each(function() {
        $(this).farbtastic($(this).closest('.color-picker').find('.color')).mouseup(function (){
            if (this.getAttribute('data-section') == 'shortcode') {
                colorUpdated($(this).siblings('input').data('type'), $.farbtastic($(this)).color);
            }
        });
    });

    $('.color').on('click', function() {
        $(this).closest('.color-picker').find('.color-picker-input').fadeIn();
    });

    $(document).on('mousedown', function() {
        $('.color-picker-input').each(function() {
            if ($(this).css('display') == 'block')
                $(this).fadeOut();
        });
    });

    // Reset to default colors
    $('.ess-use-default').on('click', function(evt) {
        evt.preventDefault();
        $(this).prev().val('#').get(0).style = '';
        $(this).blur();
    });

    // Buttons Order
    $('#buttons-order').sortable({
        items: '.draggable-element',
        stop: function(event, ui) {
            var buttonsOrder = '';

            $('#buttons-order > .draggable-element').each(function(index, elem) {
                buttonsOrder += $(elem).attr('id') + ',';
            });

            // remove the last comma
            buttonsOrder = buttonsOrder.slice(0, buttonsOrder.length - 1);

            $('#buttons_order').val(buttonsOrder);
        }
    });

    // Hide button from order list if excluded from use
    $('#buttons input').on('change', function(){
        $this = this;
        button = $this.value;

        if ($this.checked) {
            $('#' + button).show(200, 'linear');
        } else {
            $('#' + button).hide(200, 'linear');
        }
    });

    // Media Upload
    var mediaFrame;

    jQuery.fn.uploadMediaFile = function(button, preview_media) {
        var button_id = button.attr('id');
        var field_id = button_id.replace('_button', '');
        var preview_id = button_id.replace('_button', '_preview');

        // If the media frame already exists, reopen it.
        if (mediaFrame) {
          mediaFrame.open();
          return;
        }

        // Create the media frame.
        mediaFrame = wp.media.frames.mediaFrame = wp.media({
          title: jQuery(this).data('uploader_title'),
          button: {
            text: jQuery(this).data('uploader_button_text'),
          },
          multiple: false
        });

        // When an image is selected, run a callback.
        mediaFrame.on('select', function() {
          attachment = mediaFrame.state().get('selection').first().toJSON();
          jQuery("#"+field_id).val(attachment.id);
          if(preview_media) {
            jQuery("#"+preview_id).attr('src',attachment.sizes.thumbnail.url);
          }
        });

        // Finally, open the modal
        mediaFrame.open();
    }

    jQuery('.image_upload_button').click(function() {
        jQuery.fn.uploadMediaFile(jQuery(this), true);
    });

    jQuery('.image_delete_button').click(function() {
        jQuery(this).closest('td').find('.image_data_field').val('');
        jQuery('.image_preview').remove();
        return false;
    });

    // Generate Shortcode
    $('#shortcode-buttons input').on('change', function(){
        button = this.value;

        if (this.checked) {
            $('#shortcode-draggable-' + button).show(200, 'linear');
            addButton(button);
        } else {
            $('#shortcode-draggable-' + button).hide(200, 'linear');
            removeButton(button);
        }

        reorderButtons();
    });

    $('#shortcode-buttons-order').sortable({
        items: '.draggable-element',
        stop: function(event, ui){
            reorderButtons();
        }
    });

    $('#shortcode-buttons-size input').on('change', function() {
        shortcode.size = this.value
        generateShortcode();
    });

    // Reset Shortcode generator inputs
    $('#reset-shortcode-inputs').on('click', function() {
        shortcode = shortcodeDefaults;

        $('#shortcode-buttons input').attr('checked', 'checked');
        $('#shortcode-buttons-order .draggable-element').show(200, 'linear');
        $('#shortcode-buttons-order').empty().append($draggableElements);
        $('#shortcode-buttons-size input[value=medium]').attr('checked', 'checked');
        $('.ess-shortcode-use-default').click();
        $('#shortcode-holder').val('[ess]');
    });

    // Cache the initial draggable elements order
    $draggableElements = $('#shortcode-buttons-order .draggable-element');
});

function addButton(button) {
    var buttons = shortcode.buttons.split(',');
    buttons.push(button);
    buttons = buttons.join(',');

    shortcode.buttons = buttons;
}

function removeButton(button) {
    var buttons = shortcode.buttons.split(',');
    buttons.splice(buttons.indexOf(button), 1);
    buttons = buttons.join(',');

    shortcode.buttons = buttons;
}

function reorderButtons() {
    this.buttons = shortcode.buttons;
    this.temp = [];
    this.button;

    // console.log(buttons);
    var self = this;

    jQuery('#shortcode-buttons-order > .draggable-element').each(function(index, elem) {
        self.button = elem.getAttribute('data-button');

        if (self.buttons.indexOf(button) !== -1) {
            self.temp.push(button);
        }
    });

    shortcode.buttons = temp.join(',');
    generateShortcode();
}

function colorUpdated(type, color) {
    if (type == 'color') {
        shortcode.color = color;
    } else {
        shortcode.hoverColor = color;
    }

    generateShortcode();
}

function generateShortcode() {
    var s = '[ess';

    if (shortcode.buttons.length) {
        s += ' buttons="' + shortcode.buttons + '"';
    }

    s += ' size="' + shortcode.size + '"';

    if (shortcode.color != '#') {
        s += ' color="' + shortcode.color + '"';
    }

    if (shortcode.hoverColor != '#') {
        s += ' hover_color="' + shortcode.hoverColor + '"';
    }

    s += ']';

    jQuery('#shortcode-holder').val(s);
    shortcodeUpdateNotice();
}

// Blinks shortcode update notice right above the shortcode box
function shortcodeUpdateNotice() {
    // clearn any past intervals
    clearInterval(blink);

    var count = 1;

    blink = setInterval(function() {
        if ($shortcodeUpdateElem.style.visibility == 'hidden') {
            $shortcodeUpdateElem.style.visibility = 'visible';
        } else {
            $shortcodeUpdateElem.style.visibility = 'hidden';
        }

        if ( count >= 7 ) {
            clearInterval(blink);
            $shortcodeUpdateElem.style.visibility = 'hidden';
        }
        count++;

    }, 400);
}